#include <vector> 
#include <algorithm> 
#include <iostream> 
#include <fstream>	
#include <iomanip>	
using namespace std;

struct autost
{
char rendszam[8], tipus[20];
double ar;
unsigned int ev;
};

class autok
{
private:
	vector <autost> tomb; 
	ifstream be;
public:
	autok(char fnev[]);
	~autok(){be.close(); tomb.clear();}
	void feltolt();
	int elemszam(){return (int)tomb.size();}
	void kiir();
	bool keres(char *rsz);
	bool torol(char *rsz);
	int dragabbmint2millio();
};

int main()
{
	setlocale(LC_ALL, "Hun");

	autok obj("autok.dat");
	obj.feltolt();
	obj.kiir();
	cout<<"\nAz autk szma: "<<obj.elemszam()<<endl;
	cout<<"\nA 2 millinl drgbb autk szma: "<<obj.dragabbmint2millio()<<endl<<endl;

	system("pause");
	return 0;
}

autok::autok(char fnev[])
{
	be.open(fnev, ios::binary);
	if(!be)
	{
		cerr<<fnev<<" nem ltezik!\n\a";
		system("pause");
		exit(1);
	}
}

void autok::feltolt()
{
	autost adat;
	while(be.read((char*)&adat, sizeof(autost)))
	{
		tomb.push_back(adat);
	}
}

void autok::kiir()
{
	cout<<"\nRendszm\tTpus\t\tr\tv\n\n"; 
	cout.setf(ios::fixed|ios::left); 
	for(int i=0; i<elemszam(); i++)
		cout<<setw(8)<<tomb[i].rendszam<<setw(20)<<tomb[i].tipus
			<<setw(10)<<setprecision(0)<<tomb[i].ar<<setw(6)<<tomb[i].ev<<endl;
}

int autok::dragabbmint2millio()
{
	int db=0;
	cout << "\nA 2000000 Ft-nl drgbb autk:" << endl;
	for(int i=0; i<elemszam(); i++)
	{
		if (tomb[i].ar > 2000000)
		{
			++db;
			cout<<setw(8)<<tomb[i].rendszam<<setw(20)<<tomb[i].tipus
				<<setw(10)<<setprecision(0)<<tomb[i].ar<<setw(6)<<tomb[i].ev<<endl;
		}
	}
	return db;
}