#include<iostream>
#include<fstream>
#include<list>
#include<iomanip>
#include<algorithm>

using namespace std;

struct eredmeny
{
	char egyesulet[30];
	char nev[25];
	double ido;
};
class lanc
{
private:
	list<eredmeny>lista;
public:
	lanc(char *);
	~lanc();
	void beolvas(char* fnev);
	void kiir();
	double legjobb();
	int egyesuletek();
	int kerddb();
};
lanc::lanc(char* fnev)
{
	ifstream be(fnev,ios::binary);
	if (!be)
	{
		cerr<<"nem sikerult megnyitni!"<<endl;
		system("pause");
		exit(1);
	}
}
lanc::~lanc()
{
	lista.clear();
}
void lanc::beolvas(char* fnev)
{
	ifstream be(fnev,ios::binary);
	const int MAX=80;
	char sor[MAX]="";
	unsigned int db=0;
	if (be)
	{
		eredmeny ered;
		while(be.read((char *) &ered,sizeof(eredmeny)))
		{
			lista.push_front(ered);
			db++;
		}
	}
	

}
void lanc::kiir()
{
	cout<<"egyesulet			nev			ido"<<endl;
	cout.setf(ios::fixed);
	cout.setf(ios::left);
	for(list<eredmeny>::const_iterator i=lista.begin();i!=lista.end();i++)
		cout<<setw(30)<<i->egyesulet<<setw(25)<<i->nev<<setw(15)<<i->ido<<endl;

}
int lanc::kerddb()
{
	return lista.size();
}
bool nagyobb(eredmeny e1, eredmeny e2)
{
	return (e1.ido>e2.ido);
}
double lanc::legjobb()
{
	
	list<eredmeny>::const_iterator i=max_element(lista.begin(),lista.end(),nagyobb);
	cout<<setw(30)<<i->egyesulet<<setw(25)<<i->nev<<setw(15)<<i->ido<<endl;

	return i->ido;
}

/*
int main()
{
	lanc obj("eredmeny.dat");
	obj.beolvas("eredmeny.dat");
	obj.kiir();
	cout<<"darabszam: "<<obj.kerddb()<<endl;
	
	cout<<"legjobb eredmeny: "<<obj.legjobb()<<endl;
	
	
	
	system("pause");
	return 0;
	
}*/

void main()//int ArgDb, char *ArgTmb[]
{
		char fnev[14]=("eredmeny.dat");
	lanc l(fnev);
		l.beolvas(fnev);//ArgTmb[1]
		l.kiir();
		cout<<"darabszam: "<<l.kerddb()<<endl;
	
		cout<<"legjobb eredmeny: "<<endl;
		l.legjobb();
		system("pause");
}