#include <iostream>
#include <iomanip>
#include <fstream>

using namespace std;

struct szigo
{
	char nev[35], datum[12];
	unsigned int program_pont, elmeleti_pont;
};

class dintomb
{
private:
	szigo *ptr;
	int db;
	ifstream be;
public:
	dintomb(char*);
	~dintomb();
	void beolvas();
	void kiir();
	int szamol();
	int mikor(); //nem alap
};

void main()
{
	dintomb *d;
	char fnev[14]="szigorlat.dat";
	d=new dintomb(fnev);
	d->beolvas();
	d->kiir();
	cout << endl << "Darabszam:";
	cout << d->mikor();
	cout << endl;
	delete d;
}

dintomb::dintomb(char fnev[])
{
	ptr=NULL;
	db=0;
	be.open(fnev,ios::binary);
	if(be.fail())
	{
		cerr << "\nHibas fajlnev!\a\n" << endl;
		exit(1);
	}
}

dintomb::~dintomb()
{
	if(ptr!=NULL)
	{
		delete []ptr;
		ptr=NULL;
		db=0;
	}
}

void dintomb::beolvas()
{
	be.seekg(0,ios::end);
	db=be.tellg()/sizeof(szigo);
	be.seekg(0,ios::beg);
	ptr=new szigo[db];
	be.read((char*)ptr,db*sizeof(szigo));
	be.close();
}

void dintomb::kiir()
{
	cout.setf(ios::fixed);
	cout.setf(ios::left);
	cout << "Datum         Nev              Elm.pont           Gyak.pont\n\n";
	for(register int i=0; i<db; i++)
	{
		cout << setw(13) << ptr[i].datum << setw(20) << ptr[i].nev << setw(15) << ptr[i].elmeleti_pont
			<< ptr[i].program_pont << endl;
	}
}

int dintomb::szamol()
{
	return db;
}

int dintomb::mikor()
{
	char datum_be[12];
	cout << "\nAdd meg a datumot (eeee.hh.nn.): \n";
	cin >> datum_be;
	int x=0;
	for(int i=0;i<db;i++)
	{
		if(datum_be==ptr[i].datum)
			x=x+1;
	}
	return x;
}